
import hpjava.* ;


class Producer extends Thread {
  Port prev, next, out ;
  int id ;

  public Producer(Port prev, Port next, int id, Port out) {
    this.prev = prev ;
    this.next = next ;
    this.out  = out  ;

    this.id = id ;
  }

  public Producer(Port prev, Port next, int id) {
    this.prev = prev ;
    this.next = next ;
    this.out  = new Port() ;

    this.id = id ;
  }

  public void run() {
//    if(id == 0 ) {
//      out.sendInt(id) ;
//      next.sendChan(out) ;
//    }
//    while(true) {
//      prev.recvChan(out) ;
//      out.sendInt(id) ;
//      next.sendChan(out) ;
//    }
    if(id == 0 )
      for(int i = 0 ; i < 20 ; i++) {
	out.sendInt(id) ;
	next.sendChan(out) ;
	prev.recvChan(out) ;
      }
    else
      for(int i = 0 ; i < 20 ; i++) {
	prev.recvChan(out) ;
	out.sendInt(id) ;
	next.sendChan(out) ;
      }
  }
}


class Consumer extends Thread {
  Port in ;

  public Consumer (Port in) {
    this.in = in ;
  }

  public void run() {
    //while(true) {
    for(int i = 0 ; i < 60 ; i++) {
      int result = in.recvInt() ;
      System.out.println(result) ;
    }
  }
}

public class Eg4 {
  static final int n = 3 ;

  public static void main(String args[]) {

    // Create output channel

    Port R = new Port() ;
    Port S = new Port() ;

    Port.channel(R, S) ;

    // Create a ring of channels

    Port P [] = new Port [n] ;
    Port Q [] = new Port [n] ;

    for(int i = 0 ; i < n ; i++) {
      P [i] = new Port() ;
      Q [i] = new Port() ;
    }

    for(int i = 0 ; i < n ; i++)
      Port.channel(P [i], Q [(i + 1) % n]) ;

    // Fork a ring of producers

    (new Producer(Q [0], P [0], 0, R)).start() ;
    for(int i = 1 ; i < n ; i++)
      (new Producer(Q [i], P [i], i)).start() ;

    // Fork a consumer

    (new Consumer(S)).start() ;
  }
}


